$!+  DIR-MENU.COM
$!
$!!  PURPOSE: To select local subdirectories via menu numbers:
$!
$!!  AUTHOR:  Alan E. Feldman
$!
$    SET SYMBOL/SCOPE=(NOLOCAL,NOGLOBAL)/VERB
$!
$    WSO := WRITE SYS$OUTPUT
$
$    IF (F$TYPE(TO).EQS."")
$    THEN
$        WSO "You must define the symbol TO to a set default program"
$        WSO "before using this program. "
$    ENDIF
$
$    STATUS = 1
$    ON CONTROL_Y THEN GOTO _CONTROL_Y
$    ON WARNING THEN GOTO _ERROR
$    ORIGINAL_DIRM_DEF = F$ENVIRONMENT("DEFAULT")
$_NEXT_LEVEL:
$        CUR_DEF = F$ENVIRONMENT("DEFAULT")
$        CUR_NOCONC = F$PARSE(CUR_DEF,,,"DEVICE","NO_CONCEAL") + F$PARSE(CUR_DEF,,,"DIRECTORY","NO_CONCEAL") - "][" - "><"
$        _OUTPUT = "N " + CUR_NOCONC
$        WRITE SYS$OUTPUT _OUTPUT
$        _PREFIX = "[." 
$        _CUR_DIR = F$DIRECTORY()
$        INDENT = F$LENGTH(_CUR_DIR) - 4
$        IF (INDENT.LE.0) THEN INDENT = 0
$        IF (_CUR_DIR .EQS. "[000000]") THEN _PREFIX = "["
$        N = -1
$        _OUTPUT = F$FAO("   U!2AS!42AS","","[-]")
$        WRITE SYS$OUTPUT _OUTPUT
$        N = 0
$        _OUTPUT = F$FAO(" Return!2AS!AS","",_CUR_DIR)
$        WRITE SYS$OUTPUT _OUTPUT
$    _LOOP:
$            N = N + 1
$            _FILE_SPEC = F$SEARCH("''P1'*.DIR;")
$            IF (_FILE_SPEC .EQS. "") THEN GOTO _SELECT
$            _DIR_NAME_'N' = F$PARSE(_FILE_SPEC,,,"NAME")
$            _DIR_SPEC_'N' = _PREFIX + _DIR_NAME_'N' + "]" 
$            _OUTPUT = F$FAO("       !''INDENT'AS!4SL!2AS!42AS","",N,"",_DIR_SPEC_'N')
$            WRITE SYS$OUTPUT _OUTPUT
$            GOTO _LOOP
$    _SELECT:
$        READ/PROMPT="Make selection: " SYS$COMMAND _SELECTION
$        IF (F$EDIT(F$STRING(_SELECTION),"UPCASE") .EQS. "N") THEN GOTO _NOCONC
$        IF (F$STRING(_SELECTION) .EQS. "U" .OR. F$STRING(_SELECTION) .EQS. "u") THEN GOTO _UP
$        IF (_SELECTION .EQ. 0 .OR _SELECTION .EQS. "") THEN GOTO _SHOW_DEF
$        IF (_SELECTION .EQ. -1) THEN GOTO _UP
$        _DIR = _DIR_SPEC_'_SELECTION' 
$        SET DEFAULT '_DIR'
$        GOTO _NEXT_LEVEL
$_SHOW_DEF:
$    CURRENT_DEF = F$ENVIRONMENT("DEFAULT")
$    SET DEFAULT 'ORIGINAL_DIRM_DEF' ! To avoid "You are already there!" message
$    'TO' 'CURRENT_DEF'
$!------    $    TO ""
$    GOTO _EXIT
$
$_UP:
$    SET DEFAULT [-]
$    GOTO _NEXT_LEVEL
$
$_NOCONC:
$    SET DEFAULT 'CUR_NOCONC'
$    GOTO _NEXT_LEVEL
$
$_CONTROL_Y:
$    STATUS = %X1800800C
$    SET NOON
$    WSO "%DIRM-E-CONTROLY, control-y pressed, returning to original default"
$    SET DEFAULT 'ORIGINAL_DIRM_DEF'
$    SHOW DEFAULT
$    GOTO _EXIT
$
$_ERROR:
$    STATUS = $STATUS
$    SET NOON
$    WSO "%DIRM-E-ERRRETDEF, error, returning to original default"
$    SET DEFAULT 'ORIGINAL_DIRM_DEF'
$    SHOW DEFAULT
$    GOTO _EXIT
$
$_EXIT:
$    SET NOON
$    EXIT STATUS.OR.%X10000000
