$!+  SAVE_DEFAULT.COM
$!
$!!  PURPOSE: Assigns the current default to a logical name
$!
$!!  Recommended setup: $ SAVE :== @disk:[dir]SAVE_DEFAULT.COM
$
$!!  PARAMETERS:  
$!     P1 - Logical name for saved directory-spec [default = [TO_]SAVE].
$!     P2 - Logical name table to use [default = process]
$!
$    ON CONTROL_Y THEN EXIT %X1800800C
$    ON WARNING THEN EXIT
$
$    IF (P2.EQS."") THEN  P2 = "PROCESS"
$    HERE = F$TRNLNM("TO_0")
$    IF (HERE.EQS."") THEN HERE = F$ENVIRONMENT("DEFAULT")	! In case user doesn't use TO.COM
$
$    IF (P1.NES."")
$    THEN
$        DEFINE 'P1' 'HERE' /'P2'	! for user-specified LNM
$        SHOW LOGICAL 'P1'  /'P2'
$    ELSE
$        DEFINE TO_SAVE 'HERE' /'P2'
$        SHOW LOGICAL TO_SAVE  /'P2'
$        IF (F$TRNLNM("TO_BACK")) 
$        THEN 
$            DEFINE SAVE 'HERE' /'P2'
$            SHOW LOGICAL SAVE  /'P2'
$        ENDIF
$    ENDIF
$
$    EXIT
$!
$!# END OF SAVE_DEFUALT.COM
